From a34bd1bdfc75c5168ac1523191de62ad9e67ee81 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Fri, 1 Dec 2023 10:44:41 +0100
Subject: [PATCH 30/54] feat: headerbar in its own module; derive debug for
 many structs

---
 lact-gui/src/app/apply_box.rs                 |  2 +-
 lact-gui/src/app/gpu_selector.rs              |  2 +-
 lact-gui/src/app/headerbar.rs                 | 25 ++++++++++++++++++
 lact-gui/src/app/mod.rs                       | 26 +++++++++----------
 lact-gui/src/app/root_stack/info_page/mod.rs  |  2 +-
 .../root_stack/info_page/vulkan_info/mod.rs   |  2 +-
 lact-gui/src/app/root_stack/mod.rs            |  4 +--
 .../app/root_stack/oc_page/clocks_frame.rs    |  2 +-
 lact-gui/src/app/root_stack/oc_page/mod.rs    |  2 +-
 .../root_stack/oc_page/performance_frame.rs   |  2 +-
 .../thermals_page/fan_curve_frame/mod.rs      |  2 +-
 .../fan_curve_frame/point_adjustment.rs       |  2 +-
 .../src/app/root_stack/thermals_page/mod.rs   |  2 +-
 13 files changed, 50 insertions(+), 25 deletions(-)
 create mode 100644 lact-gui/src/app/headerbar.rs

diff --git a/lact-gui/src/app/apply_box.rs b/lact-gui/src/app/apply_box.rs
index 58054b2d..dbe331a5 100644
--- a/lact-gui/src/app/apply_box.rs
+++ b/lact-gui/src/app/apply_box.rs
@@ -1,7 +1,7 @@
 use gtk::prelude::*;
 use gtk::*;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct ApplyBox {
     pub container: Box,
     apply_button: Button,
diff --git a/lact-gui/src/app/gpu_selector.rs b/lact-gui/src/app/gpu_selector.rs
index f1668b1d..3f7ae931 100644
--- a/lact-gui/src/app/gpu_selector.rs
+++ b/lact-gui/src/app/gpu_selector.rs
@@ -3,7 +3,7 @@ use gtk::*;
 use lact_client::schema::DeviceListEntry;
 use pango::EllipsizeMode;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct GpuSelector {
     pub dropdown: ComboBoxText,
 }
diff --git a/lact-gui/src/app/headerbar.rs b/lact-gui/src/app/headerbar.rs
new file mode 100644
index 00000000..f40bf774
--- /dev/null
+++ b/lact-gui/src/app/headerbar.rs
@@ -0,0 +1,25 @@
+use super::{apply_box::ApplyBox, gpu_selector::GpuSelector};
+
+#[derive(Debug, Clone)]
+pub struct Headerbar {
+    pub container: libadwaita::HeaderBar,
+    pub gpu_selector: GpuSelector,
+    pub apply_box: ApplyBox,
+}
+
+impl Headerbar {
+    pub fn new() -> Self {
+        let container = libadwaita::HeaderBar::builder().show_title(false).build();
+        let gpu_selector = GpuSelector::new();
+        let apply_box = ApplyBox::new();
+
+        container.pack_start(&gpu_selector.dropdown);
+        container.pack_end(&apply_box.container);
+
+        Self {
+            container,
+            gpu_selector,
+            apply_box,
+        }
+    }
+}
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index b45a252e..fc5fa145 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -1,10 +1,12 @@
 mod apply_box;
 mod gpu_selector;
+mod headerbar;
 mod info_row;
 mod page_section;
 mod root_stack;
 
 use self::apply_box::ApplyBox;
+use self::headerbar::Headerbar;
 use crate::{APP_ID, GUI_VERSION};
 use anyhow::{anyhow, Context};
 use glib::clone;
@@ -15,7 +17,7 @@ use lact_client::schema::request::{ConfirmCommand, SetClocksCommand};
 use lact_client::schema::DeviceStats;
 use lact_client::DaemonClient;
 use lact_daemon::MODULE_CONF_PATH;
-use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt, NavigationPageExt};
+use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt};
 use root_stack::RootStack;
 use std::cell::RefCell;
 use std::rc::Rc;
@@ -40,7 +42,6 @@ impl App {
     pub fn new(daemon_client: DaemonClient) -> Self {
         let application = libadwaita::Application::new(Some(APP_ID), ApplicationFlags::default());
 
-        let gpu_selector = GpuSelector::new();
         let window = libadwaita::ApplicationWindow::builder()
             .title("LACT")
             .default_width(820)
@@ -64,16 +65,15 @@ impl App {
 
         let root_view = libadwaita::ToolbarView::new();
 
-        let root_view_headerbar = libadwaita::HeaderBar::builder().show_title(false).build();
-        let apply_box = ApplyBox::new();
-        root_view_headerbar.pack_start(&gpu_selector.dropdown);
-        root_view_headerbar.pack_end(&apply_box.container);
+        let headerbar = Headerbar::new();
 
-        root_view.add_top_bar(&root_view_headerbar);
-        root_view.add_bottom_bar(&libadwaita::ViewSwitcherBar::builder()
-            .reveal(true)
-            .stack(&root_stack.container)
-            .build());
+        root_view.add_top_bar(&headerbar.container);
+        root_view.add_bottom_bar(
+            &libadwaita::ViewSwitcherBar::builder()
+                .reveal(true)
+                .stack(&root_stack.container)
+                .build(),
+        );
         root_view.set_content(Some(&root_stack.container));
 
         window.set_content(Some(&root_view));
@@ -81,9 +81,9 @@ impl App {
         App {
             application,
             window,
-            gpu_selector,
+            gpu_selector: headerbar.gpu_selector,
             root_stack,
-            apply_box,
+            apply_box: headerbar.apply_box,
             daemon_client,
         }
     }
diff --git a/lact-gui/src/app/root_stack/info_page/mod.rs b/lact-gui/src/app/root_stack/info_page/mod.rs
index 5037b80b..4d01573b 100644
--- a/lact-gui/src/app/root_stack/info_page/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/mod.rs
@@ -7,7 +7,7 @@ use gtk::*;
 use lact_client::schema::{DeviceInfo, DeviceStats};
 use vulkan_info::VulkanInfoFrame;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct InformationPage {
     pub container: ScrolledWindow,
     gpu_name_row: LabelRow,
diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
index ed216995..eb25bc6e 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/mod.rs
@@ -10,7 +10,7 @@ use lact_client::schema::VulkanInfo;
 use libadwaita::prelude::ActionRowExt;
 use tracing::trace;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct VulkanInfoFrame {
     pub container: ListBox,
     device_name_row: LabelRow,
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 06f7f147..00ee7b2a 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -11,7 +11,7 @@ use libadwaita::prelude::ActionRowExt;
 use oc_page::OcPage;
 use thermals_page::ThermalsPage;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct RootStack {
     pub container: libadwaita::ViewStack,
     pub info_page: InformationPage,
@@ -51,7 +51,7 @@ impl RootStack {
     }
 }
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct LabelRow {
     pub container: libadwaita::ActionRow,
     content_label: Label,
diff --git a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
index 0a43ef76..216b34d4 100644
--- a/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/clocks_frame.rs
@@ -12,7 +12,7 @@ use tracing::debug;
 const VOLTAGE_OFFSET_RANGE: f64 = 250.0;
 
 // The AtomicBool stores if the value was changed
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct ClocksFrame {
     pub container: PageSection,
     max_values_box: Box,
diff --git a/lact-gui/src/app/root_stack/oc_page/mod.rs b/lact-gui/src/app/root_stack/oc_page/mod.rs
index a112ddbe..3d086b4e 100644
--- a/lact-gui/src/app/root_stack/oc_page/mod.rs
+++ b/lact-gui/src/app/root_stack/oc_page/mod.rs
@@ -23,7 +23,7 @@ use super::list_clamp;
 use std::collections::HashMap;
 use tracing::warn;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct OcPage {
     pub container: ScrolledWindow,
     stats_section: GpuStatsSection,
diff --git a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
index 5723e758..52187ba8 100644
--- a/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
+++ b/lact-gui/src/app/root_stack/oc_page/performance_frame.rs
@@ -8,7 +8,7 @@ use lact_client::schema::amdgpu_sysfs::gpu_handle::{
 use libadwaita::prelude::{ActionRowExt, ComboRowExt};
 use std::{cell::RefCell, rc::Rc, str::FromStr};
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct PerformanceFrame {
     pub container: PageSection,
     level_row: libadwaita::ComboRow,
diff --git a/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/mod.rs b/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/mod.rs
index 852aded7..970d078a 100644
--- a/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/mod.rs
@@ -9,7 +9,7 @@ use std::cell::RefCell;
 use std::collections::BTreeMap;
 use std::rc::Rc;
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct FanCurveFrame {
     pub container: Box,
     curve_container: ScrolledWindow,
diff --git a/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/point_adjustment.rs b/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/point_adjustment.rs
index 288498e9..7cf5c2d5 100644
--- a/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/point_adjustment.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/fan_curve_frame/point_adjustment.rs
@@ -6,7 +6,7 @@ use gtk::{
     Adjustment, Box, Label, MenuButton, Orientation, Popover, Scale, SpinButton,
 };
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct PointAdjustment {
     pub temperature: Adjustment,
     pub ratio: Adjustment,
diff --git a/lact-gui/src/app/root_stack/thermals_page/mod.rs b/lact-gui/src/app/root_stack/thermals_page/mod.rs
index 79a8a562..5a9f4ce5 100644
--- a/lact-gui/src/app/root_stack/thermals_page/mod.rs
+++ b/lact-gui/src/app/root_stack/thermals_page/mod.rs
@@ -17,7 +17,7 @@ pub struct ThermalsSettings {
     pub curve: Option<FanCurveMap>,
 }
 
-#[derive(Clone)]
+#[derive(Debug, Clone)]
 pub struct ThermalsPage {
     pub container: ScrolledWindow,
     temperatures_row: LabelRow,

